/* ########## 4.11 Typography ########## */

// Font family
.u-font--roboto        { font-family: $font-family-roboto; }
.u-font--opensans      { font-family: $font-family-opensans; }

// Font weights
.u-font--bold      { font-weight: 700 !important; }
.u-font--semibold  { font-weight: 600 !important; }
.u-font--medium    { font-weight: 500 !important; }
.u-font--normal    { font-weight: 400 !important; }
.u-font--light     { font-weight: 300 !important; }
.u-font--thin      { font-weight: 200 !important; }
.u-font--xthin     { font-weight: 100 !important; }

// Font colors
.u-fg--black           { color: #000 !important; }
.u-fg--inverse         { color: $gray-dark !important; }
.u-fg--gray-dark       { color: $gray-800 !important; }
.u-fg--gray            { color: $gray-600 !important; }
.u-fg--gray-light      { color: $gray-500 !important; }
.u-fg--gray-lighter    { color: $gray-400 !important; }
.u-fg--gray-lightest   { color: $gray-300 !important; }
.u-fg--primary         { color: $brand-primary !important; }
.u-fg--success         { color: $brand-success !important; }
.u-fg--warning         { color: $brand-warning !important; }
.u-fg--danger          { color: $brand-danger !important; }
.u-fg--info            { color: $brand-info !important; }
.u-fg--maroon          { color: $color-maroon !important; }
.u-fg--pink            { color: $color-pink !important; }
.u-fg--pink-light      { color: $color-pink-light !important; }
.u-fg--yellow          { color: $color-yellow !important; }
.u-fg--orange          { color: $color-orange !important; }
.u-fg--indigo          { color: $color-indigo !important; }
.u-fg--indigo-light    { color: $color-indigo-light !important; }
.u-fg--teal            { color: $color-teal !important; }
.u-fg--turquiose       { color: $color-turquiose !important; }
.u-fg--flesh           { color: $color-flesh !important; }

// Text white
.u-fg--white           { color: #fff !important; }
.u-fg--white-9         { color: rgba(#fff, 0.9); }
.u-fg--white-8         { color: rgba(#fff, 0.8); }
.u-fg--white-7         { color: rgba(#fff, 0.7); }
.u-fg--white-6         { color: rgba(#fff, 0.6); }
.u-fg--white-5         { color: rgba(#fff, 0.5); }
.u-fg--white-4         { color: rgba(#fff, 0.4); }
.u-fg--white-3         { color: rgba(#fff, 0.3); }
.u-fg--white-2         { color: rgba(#fff, 0.2); }
.u-fg--white-1         { color: rgba(#fff, 0.1); }


// Font spacing
.u-txt__spacing--1 { letter-spacing: 0.5px; }
.u-txt__spacing--2 { letter-spacing: 1px; }
.u-txt__spacing--3 { letter-spacing: 1.5px; }
.u-txt__spacing--4 { letter-spacing: 2px; }
.u-txt__spacing--5 { letter-spacing: 2.5px; }
.u-txt__spacing--6 { letter-spacing: 3px; }
.u-txt__spacing--7 { letter-spacing: 3.5px; }
.u-txt__spacing--8 { letter-spacing: 4px; }

.u-txt__spacing--neg-1 { letter-spacing: -0.5px; }
.u-txt__spacing--neg-2 { letter-spacing: -1px; }
.u-txt__spacing--neg-3 { letter-spacing: -1.5px; }
.u-txt__spacing--neg-4 { letter-spacing: -2px; }
.u-txt__spacing--neg-5 { letter-spacing: -2.5px; }
.u-txt__spacing--neg-6 { letter-spacing: -3px; }
.u-txt__spacing--neg-7 { letter-spacing: -3.5px; }
.u-txt__spacing--neg-8 { letter-spacing: -4px; }

// Others
.u-txt--shadow { text-shadow: 1px 1px 3px rgba(0,0,0,0.3); }

.u-txt--uppercase { text-transform: uppercase !important; }
.u-txt--lowercase { text-transform: lowercase !important; }
.u-txt--transform-none { text-transform: none !important; }

.u-txt--center { text-align: center !important; }
.u-txt--right { text-align: right !important; }
.u-txt--left { text-align: left !important; }

.u-txt--italic { font-style: italic !important; }
.u-txt--normal { font-style: normal !important; }

// Line Height
.u-txt__lh--base   { line-height: $line-height-base; }
.u-txt__lh--normal { line-height: normal; }

.u-txt__lh--0 { line-height: 0 !important; }
.u-txt__lh--1 { line-height: 1.1 !important; }
.u-txt__lh--2 { line-height: 1.2 !important; }
.u-txt__lh--3 { line-height: 1.3 !important; }
.u-txt__lh--4 { line-height: 1.4 !important; }
.u-txt__lh--5 { line-height: 1.5 !important; }
.u-txt__lh--6 { line-height: 1.6 !important; }
.u-txt__lh--7 { line-height: 1.7 !important; }
.u-txt__lh--8 { line-height: 1.8 !important; }
.u-txt__lh--9 { line-height: 1.9 !important; }
.u-txt__lh--10 { line-height: 2.0 !important; }
.u-txt__lh--11 { line-height: 2.1 !important; }
.u-txt__lh--12 { line-height: 2.2 !important; }
.u-txt__lh--13 { line-height: 2.3 !important; }
.u-txt__lh--14 { line-height: 2.4 !important; }
.u-txt__lh--15 { line-height: 2.5 !important; }

.u-txt__lh--9 { line-height: 0.9; }
.u-txt__lh--8 { line-height: 0.8; }
.u-txt__lh--7-5 { line-height: 0.75; }

.u-txt__lh--30px { line-height: 30px; }

// Vertical align
.u-valign--top { vertical-align: top !important; }
.u-valign--middle { vertical-align: middle !important; }
.u-valign--bottom { vertical-align: baseline !important; }
.u-valign__text-top { vertical-align: text-top !important; }
.u-valign__text-bottom { vertical-align: text-bottom !important; }
.u-valign--sub { vertical-align: sub !important; }
.u-valign--super { vertical-align: super !important; }

// Font sizes
.u-display--5 {
  font-size: 3rem;
  font-weight: 300;
}

.u-font--base {
  font-size: $font-size-base ;
  line-height: $line-height-base;
}

.u-font--sm {
  font-size: $font-size-sm;
  line-height: 1.6;
}

.u-font--xs {
  font-size: $font-size-xs;
  line-height: 1.5;
}

.u-font--lg { font-size: $font-size-lg; }

@mixin font-size($num, $viewport:"") {
  @if $viewport == "" {
    $viewport: "-";
  } @else {
    $viewport: "-" + $viewport + "-";
  }

  .u-font#{$viewport}-#{$num} { font-size: #{$num}px !important; }
  .u-lh#{$viewport}-#{$num} { line-height: #{$num}px !important; }
}

@mixin do-font-size($viewport) {
  $num: 8;
  @while $num <= 16 {
    @include font-size($num,$viewport);
    $num: $num + 1;
  }

  $num: 18;
  @while $num <= 140 {
    @include font-size($num,$viewport);
    $num: $num + 2;
  }
}



@mixin do-font-breakpoint($viewport) {
  .u-font-#{$viewport}--bold      { font-weight: 700; }
  .u-font-#{$viewport}--semibold  { font-weight: 600; }
  .u-font-#{$viewport}--medium    { font-weight: 500; }
  .u-font-#{$viewport}--normal    { font-weight: 400; }
  .u-font-#{$viewport}--light     { font-weight: 300; }
  .u-font-#{$viewport}--thin      { font-weight: 200; }
  .u-font-#{$viewport}--xthin     { font-weight: 100; }

  .u-txt__lh-#{$viewport}--0 { line-height: 0; }
  .u-txt__lh-#{$viewport}--1 { line-height: 1.1; }
  .u-txt__lh-#{$viewport}--2 { line-height: 1.2; }
  .u-txt__lh-#{$viewport}--3 { line-height: 1.3; }
  .u-txt__lh-#{$viewport}--4 { line-height: 1.4; }
  .u-txt__lh-#{$viewport}--5 { line-height: 1.5; }
  .u-txt__lh-#{$viewport}--6 { line-height: 1.6; }
  .u-txt__lh-#{$viewport}--7 { line-height: 1.7; }
  .u-txt__lh-#{$viewport}--8 { line-height: 1.8; }
  .u-txt__lh-#{$viewport}--9 { line-height: 1.9; }
  .u-txt__lh-#{$viewport}--10 { line-height: 2.0; }
  .u-txt__lh-#{$viewport}--11 { line-height: 2.1; }
  .u-txt__lh-#{$viewport}--12 { line-height: 2.2; }
  .u-txt__lh-#{$viewport}--13 { line-height: 2.3; }
  .u-txt__lh-#{$viewport}--14 { line-height: 2.4; }
  .u-txt__lh-#{$viewport}--15 { line-height: 2.5; }

  .u-fg-#{$viewport}--white { color: #fff !important; }
  .u-fg-#{$viewport}--inverse { color: $gray-dark !important; }
  .u-fg-#{$viewport}--gray { color: $gray !important; }

  .u-txt__spacing-#{$viewport}--2 { letter-spacing: 1px; }
  .u-txt__spacing-#{$viewport}--4 { letter-spacing: 2px; }
  .u-txt__spacing-#{$viewport}--6 { letter-spacing: 3px; }
  .u-txt__spacing-#{$viewport}--8 { letter-spacing: 4px; }

  .u-txt__spacing-#{$viewport}--neg-2 { letter-spacing: -1px; }
  .u-txt__spacing-#{$viewport}--neg-4 { letter-spacing: -2px; }
  .u-txt__spacing-#{$viewport}--neg-6 { letter-spacing: -3px; }
  .u-txt__spacing-#{$viewport}--neg-8 { letter-spacing: -4px; }

  .u-txt-#{$viewport}--center { text-align: center !important; }
  .u-txt-#{$viewport}--right { text-align: right !important; }
  .u-txt-#{$viewport}--left { text-align: left !important; }
}

$num: 8;
@while $num <= 16 {
  @include font-size($num);
  $num: $num + 1;
}

$num: 18;
@while $num <= 140 {
  @include font-size($num);
  $num: $num + 2;
}

@media (min-width: 480px) {
  @include do-font-size("xs");
  @include do-font-breakpoint("xs");
}

@include media-breakpoint-up(sm) {
  @include do-font-size("sm");
  @include do-font-breakpoint("sm");
}

@include media-breakpoint-up(md) {
  @include do-font-size("md");
  @include do-font-breakpoint("md");
}

@include media-breakpoint-up(lg) {
  @include do-font-size("lg");
  @include do-font-breakpoint("lg");
}

@include media-breakpoint-up(xl) {
  @include do-font-size("xl");
  @include do-font-breakpoint("xl");
}

.c-txt-line--1 {
  display: -webkit-box !important;
  white-space: normal;
  word-break: normal;
  overflow: hidden;
  text-overflow: ellipsis;
  -webkit-box-orient: vertical;
  -webkit-line-clamp: 1 !important;
}

.c-txt-line--2 {
  display: -webkit-box !important;
  white-space: normal;
  word-break: normal;
  overflow: hidden;
  text-overflow: ellipsis;
  -webkit-box-orient: vertical;
  -webkit-line-clamp: 2 !important;
  line-height: 20px;
  
  &-ht-36 {
    height: 36px;
    margin-bottom: 10px;
  }

  &-ht-50 {
    line-height: 1.8 !important;
    height: 50px;
  }
}